; FarbReset_relo setzt den FarbRam auf einen definierten Pegel
; Entwicklung von Ralph Hnsel ralphhaensel@gmx.DE

; Stand 09.11.2011 verffentlicht

;Vereinbarungen zum Monitor V8.x
;------------------------------------------------------------------------
BWS_Anfang:      EQU        1000H  ; AnfangsAdr. BWS
FarbBWS:         EQU        181FH  ; MerkZelle fr FarbBWS 00 = keineFarbe
                                   ; #181F FarbCode / war mal Hilfsreg.Tast.
ARG1:            EQU        185BH  ; 1.Argument

BWSPort:         EQU        0F0H   ; rcklesbares BWS Steuerregister


;Programmvereinbarungen
        ORG  01900H             ; Startadresse Ladetool
;
        DEFB 00H,09H,"!",0DH      ; Prolog Monitor...
        LD   A,(ARG1)
        OR   A                    ; wenn 0 dann grn setzen
        JR   NZ,WriteFarbe
        ;
FarbReset:   
        ; hier kommt INIT an und schreibt den FarbRAM mit Vorgabe
        DEFB 3EH                  ; fr LD A,...
FarbByte:
        DEFB 02H                  ; GRN Vordergrund Hintergrund schwarz
WriteFarbe:
        PUSH AF                    ; FarbByte sichern
        XOR  A                     ; noFarbRAM A=00
        LD   (FarbBWS),A           ; noFarbRAM einstellen
        POP  AF                    ; FarbByte  zurck
        LD   C,BWSPort
        IN   B,(C)                 ; akt. Portwert einlesen
        INC  B                     ; FFH wenn kein rcklesbares Register 
        RET  Z                     ; Rckkehr weil kein BWSPort gefunden
        ; wenn hier dann wurde KEIN FFH gelesen, alten Wert zurck
        DEC  B                     ; alter Wert zurck
        LD   D,B                   ; in B BWS Portwert fr Text RAM
        SET  2,D                   ; in D BWS Portwert fr FarbRAM
        ; hier nun in D und E die Steuercodes
        LD   HL,BWS_Anfang
        LD   E,(HL)                ; altes TextByte in E merken
        OUT  (C),D                 ; FarbRAM an
        LD   (HL),A                ; Farbbyte schreiben
        CP   (HL)                  ; und vergleichslesen
        OUT  (C),B                 ; Text RAM wieder ein (wegen RET)
        LD   (HL),E                ; altes Zeichen Text-RAM zurck
        RET  NZ                    ; kein phys.RAM (Text- oder FarbRAM!)
        ; Befehle bis FarbOK: knnten weggelassen werden, weil durch die
        ; Existenz des rcklesbaren BWSPort und das sich RAM beim 
        ; Umschalten auf FarbRAM meldet, der Nachweis auf den BWS erbracht
        ; ist, die Bytes testen nur, obn der RAM auch sauber trennt
;        OUT  (C),D                 ; FarbRAM an
;        LD   A,(HL)                ; Farb-RAM wieder einlesen (wenn kein
;                                   ; Farb-RAM da, dann ist A=E=Text-RAM !)
;        CP   E                     ; wenn A<>E, dann FarbRAM vorh.
;        OUT  (C),B                 ; Text RAM wieder ein (wegen RET)
;        RET  Z                     ; A=E=TextRAM Aktivierung FarbRAM klappt
;                                  ; nicht, entweder kein RAM oder BWSPort
FarbOK: ; wenn hier dann unterschiedliche RAM's! damit gilt der FarbRAM
        ; als erkannt, das 1.Byte ist bereits in Farbe
        OUT  (C),D                 ; FarbRAM an
        PUSH BC                    ; BWSPort und TextRAM ein sichern
        LD   DE,BWS_Anfang+1       ; 2.Byte FarbRAM
        LD   BC,07FFH              ; restliche Bytezahl
        LDIR                       ; nun FarbRAM schreiben
        LD   A,(HL)                ; FarbByte zurcklesen (von 17FFH)
        POP  BC                    ; BWSPort und TextRAM ein
        OUT  (C),B                 ; Text RAM ein
        LD   (FarbBWS),A           ; FarbByte eintragen
        RET                        ; Rckkehr mit NZ (noch aus CP B Befehl)
;        
;*************************************************************************
